#pragma once
#include <vector>
#include <string>
#include "../nsmsgs/dlg.h"
#include "resource.h"

typedef std::vector<std::string> StringList;

class CSettingDlg :
	public CDlg
{
private:
	StringList m_modules;
	int m_timeForBoot;
	int m_nSelected;
	bool m_bUseAutoBoot;

public:
	CSettingDlg(void);
	~CSettingDlg(void);

	void SetAutoBoot(bool boot)
	{
		m_bUseAutoBoot = boot;
	}
	bool GetAutoBoot() const
	{
		return m_bUseAutoBoot;
	}
	void AddModuleName(LPCSTR module)
	{
		m_modules.push_back(module);
	}
	void SetSelected(int sel)
	{
		m_nSelected = sel;
	}
	int GetSelected() const
	{
		return m_nSelected;
	}
	void SetTimeForBoot(int time)
	{
		m_timeForBoot = time;
	}
	int GetTimeForBoot() const
	{
		return m_timeForBoot;
	}
	void EnableItems(bool enable)
	{
		SetEnable(IDC_UI_COMBO, enable);
		SetEnable(IDC_BOOT_TIME, enable);
	}

// I[o[Ch
public:
	BOOL DlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam);

private:
	BOOL InitDlgCtrl();
	BOOL GetDlgCtrlValue();
};
