#include "StdAfx.h"
#include ".\uiplugin.h"
#include "UISelector.h"

CUIPlugin::CUIPlugin(LPCSTR fpath, LPCSTR dllName)
: m_hModule(NULL)
, m_pGetPluginInfo(NULL)
, m_dllName(dllName)
{
	char info[MAX_PATH];
	int ret;

	if( m_dllName.length() > 4 )
		m_dllName.resize(m_dllName.length() - 4);

	// DLL[h
	m_hModule = ::LoadLibrary(fpath);
	if( m_hModule == NULL ) return;

	// GetPluginInfoǂݍ
	m_pGetPluginInfo = (TGetPInfo)::GetProcAddress(m_hModule, "GetPluginInfo");

	if( m_pGetPluginInfo == NULL )
		// ǂݍݎs
	{
		Unload();
		return;
	}

	// W[^Cvǂݍ
	ret = GetPluginInfo(NMPI_MODULENAME, info, sizeof(info));

	if( ret <= 0 || strcmp(info, "UI") != 0 )
		// UIW[ł͂Ȃ
	{
		Unload();
		return;
	}
}

CUIPlugin::~CUIPlugin(void)
{
	if( m_hModule != NULL )
		Unload();
}

void CUIPlugin::Unload()
{
	::FreeLibrary(m_hModule);
	m_hModule = NULL;
}

//**********************************************************************
// RegneW[K{֐
//**********************************************************************

int CUIPlugin::GetPluginInfoOriginal(int nInfoNo, LPTSTR lpBuffer, int nSize)
{
	return m_pGetPluginInfo(nInfoNo, lpBuffer, nSize);
}

LPCSTR CUIPlugin::GetPluginInfoTmp(int nInfoNo)
{
	static char sBuf[256];
	int ret;
	
	ret = GetPluginInfoOriginal(nInfoNo, sBuf, sizeof(sBuf));
	if( ret >= 0 ){
		if( ret >= sizeof(sBuf) ) ret = sizeof(sBuf) - 1;
		sBuf[ret] = '\0';
	}else{
		sBuf[0] = '\0';
	}
	return sBuf;
}

int CUIPlugin::GetPluginInfo(int nInfoNo, LPTSTR lpBuffer, int nSize)
{
	int ret;

	ret = GetPluginInfoOriginal(nInfoNo, lpBuffer, nSize);
	if( nInfoNo == NMPI_COPYRIGHT ){
		if( ret < 0 ) ret = 0;
		strncat_s(lpBuffer, nSize-ret-1, " (" MY_NAME " " MY_VERSION ")", nSize-ret-1);
		ret = strlen(lpBuffer);
	}

	return ret;
}

int CUIPlugin::Initialize(PNsmPluginInitInfo lpNsmInitInfo)
{
	_ASSERT(m_hModule != NULL);
	int ret = NMP_ALLRIGHT;
	TInit pInit;

	pInit = (TInit)::GetProcAddress(m_hModule, "Initialize");
	if( pInit != NULL ) ret = pInit(lpNsmInitInfo);
	
	return ret;
}

int CUIPlugin::Terminate()
{
	_ASSERT(m_hModule != NULL);
	int ret = NMP_ALLRIGHT;
	TTerm pTerm;

	pTerm = (TTerm)::GetProcAddress(m_hModule, "Terminate");
	if( pTerm != NULL ) ret = pTerm();

	return ret;
}

