#pragma once
#include <string>

class CUIPlugin
{
private:
	typedef int (__stdcall *TGetPInfo)(int, LPTSTR, int);
	typedef int (__stdcall *TInit)(PNsmPluginInitInfo);
	typedef int (__stdcall *TTerm)();

private:
	std::string m_dllName;
	HMODULE m_hModule;
	TGetPInfo m_pGetPluginInfo;

private:
	const CUIPlugin& operator =(const CUIPlugin& /*other*/)
	{ _ASSERT(FALSE); }
	void Unload();
	int GetPluginInfoOriginal(int nInfoNo, LPTSTR lpBuffer, int nSize);

public:
	CUIPlugin(LPCSTR fpath, LPCSTR dllName);
	~CUIPlugin(void);

	int GetPluginInfo(int nInfoNo, LPTSTR lpBuffer, int nSize);
	int Initialize(PNsmPluginInitInfo lpNsmInitInfo);
	int Terminate();

	LPCSTR GetPluginInfoTmp(int nInfoNo);

	bool IsLoadSuccess() const
	{ return m_hModule != NULL; }
	LPCSTR GetDllName() const
	{ return m_dllName.c_str(); }
};
