#include "StdAfx.h"
#include ".\uiselectdlg.h"
#include "resource.h"

std::string CUISelectDlg::m_tipStr;
WNDPROC CUISelectDlg::m_originalListProc;


CUISelectDlg::CUISelectDlg(void)
: CDlg(IDD_MAIN)
, m_nSelected(-1)
{
}

CUISelectDlg::~CUISelectDlg(void)
{
}

//*******************************************************************
// I[o[Ch
//*******************************************************************
// ݒ_CAÕ_CAOvV[W
BOOL CUISelectDlg::DlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg){
	case WM_NOTIFY:
		switch( ((LPNMHDR)lParam)->code ){
		case TTN_GETDISPINFO:
			OnGetDispInfo((LPNMTTDISPINFO)lParam);
			break;

		default:
			return FALSE;
		}
		return TRUE;
	case WM_TIMER:
		OnTimer();
		return TRUE;

	case WM_COMMAND:
		switch(LOWORD(wParam)){
		// ݒ{^
		case IDC_SETTING_BTN:
			OnClickSetting();
			break;

		case IDC_STOP:
			OnStop();
			break;

		case IDC_LIST:
			if( HIWORD(wParam) == LBN_DBLCLK ){
				OnListDblClick();
				break;
			}
			return FALSE;

		default:
			return FALSE;
		}
		return TRUE;
	}
	return FALSE;
}

// ݒ_CAORg[
BOOL CUISelectDlg::InitDlgCtrl()
{
	ModuleList::iterator i;
	HWND hListBox;
	RECT r;
	int count;
	std::string selUI;
	char buf[MAX_PATH];

	// init
	hListBox = GetDlgItem(IDC_LIST);
	m_ini.ReadString(selUI, "Setting", "AutoBootUI", "");

	for( i = m_pList->begin(); i != m_pList->end(); i++ ){
		::SendMessage(hListBox, LB_ADDSTRING, 0,
			(LPARAM)(*i)->GetPluginInfoTmp(NMPI_TITLE));
	}
	::SendMessage(hListBox, LB_SETCURSEL, 0, 0);

	// sub classs ListCtrl
	m_originalListProc = (WNDPROC)::GetWindowLongPtr(hListBox, GWLP_WNDPROC);
	::SetWindowLongPtrA(hListBox, GWLP_WNDPROC, (LONG_PTR)NewListProc);

	// tool tip
	count = 0;
	m_tip.Create(m_hInstance, m_hDlgWnd);
	for( i = m_pList->begin(); i != m_pList->end(); i++ ){
		::SendMessage(hListBox, LB_GETITEMRECT, count++, (LPARAM)&r);
		m_tip.AddToolToToolTip(hListBox, r, (LPARAM)*i);
		if( selUI == (*i)->GetPluginInfoTmp(NMPI_TITLE) )
			::SendMessage(hListBox, LB_SETCURSEL, count-1, 0);
	}
	m_tip.Begin();

	// auto boot
	if( m_infoString.length() > 0 ){
		SetItemText(IDC_COUNT, m_infoString.c_str());
	}else if( m_bAutoBoot ){
		CUIPlugin* pui;
		pui = GetAutoBoot();
		if( pui != NULL ){
			_snprintf_s(buf, sizeof(buf), "%d b", m_timeForBoot);
			SetWindowText(GetDlgItem(IDC_COUNT), buf);
			::SetTimer(m_hDlgWnd, 1234, 1000, NULL);
		}else{
			_snprintf_s(buf, sizeof(buf), "u%sv܂", selUI.c_str());
			SetItemText(IDC_COUNT, buf);
		}
	}else{
		SetItemText(IDC_COUNT, "NOFF");
	}

	::SetWindowText(m_hDlgWnd, "Regnessem UIZN^ Ver." MY_VERSION);

	return TRUE;
}

// ݒ_CAO̒lOptionSettingsɐݒ
BOOL CUISelectDlg::GetDlgCtrlValue()
{
	m_nSelected = ::SendMessage(GetDlgItem(IDC_LIST), LB_GETCURSEL, 0, 0);

	return TRUE;
}

//*******************************************************************
// Cxgnh
//*******************************************************************

void CUISelectDlg::OnClickSetting()
{
	CSettingDlg dlg;
	std::string selUI;
	ModuleList::iterator i;
	int count;
	LPCSTR uiTitle;

	dlg.SetAutoBoot(m_ini.ReadInt("Setting", "AutoBoot", 0) != 0);
	dlg.SetTimeForBoot(m_ini.ReadInt("Setting", "TimeForBoot", 5));
	dlg.SetSelected(0);
	m_ini.ReadString(selUI, "Setting", "AutoBootUI", "");

	count = 0;
	for( i = m_pList->begin(); i != m_pList->end(); i++ ){
		uiTitle = (*i)->GetPluginInfoTmp(NMPI_TITLE);
		dlg.AddModuleName(uiTitle);
		if( uiTitle == selUI )
			dlg.SetSelected(count);
		count++;
	}

	if( dlg.DoModal(m_hInstance, m_hDlgWnd) == IDOK ){
		m_ini.Write("Setting", "AutoBoot", dlg.GetAutoBoot());
		m_ini.Write("Setting", "TimeForBoot", dlg.GetTimeForBoot());
		m_ini.Write("Setting", "AutoBootUI",
			(*m_pList)[dlg.GetSelected()]->GetPluginInfoTmp(NMPI_TITLE));
	}
}

void CUISelectDlg::OnGetDispInfo(LPNMTTDISPINFO lpttd)
{
	CUIPlugin &mi = *(CUIPlugin*)lpttd->lParam;

	m_tipStr = mi.GetPluginInfoTmp(NMPI_TITLE);
	m_tipStr += " ";
	m_tipStr += mi.GetPluginInfoTmp(NMPI_PLUGINVER);
	m_tipStr += "\r\n";
	m_tipStr += mi.GetPluginInfoTmp(NMPI_DESCRIPTION);
	m_tipStr += "\r\n";
	m_tipStr += mi.GetPluginInfoTmp(NMPI_AUTHOR);
	m_tipStr += "\r\n";
	m_tipStr += mi.GetPluginInfoTmp(NMPI_COPYRIGHT);

	::SendMessage(lpttd->hdr.hwndFrom, TTM_SETMAXTIPWIDTH, 0, 300);
	lpttd->lpszText = (LPSTR)m_tipStr.c_str();
}

void CUISelectDlg::OnTimer()
{
	std::string selUI;

	m_timeForBoot--;

	if( m_timeForBoot <= 0 ){
		m_ini.ReadString(selUI, "Setting", "AutoBootUI", "");
		::SendMessage(GetDlgItem(IDC_LIST), LB_SELECTSTRING, (WPARAM)-1, (LPARAM)selUI.c_str());
		::SendMessage(m_hDlgWnd, WM_COMMAND, IDOK, 0);
	}else{
		char buf[64];
		_snprintf_s(buf, sizeof(buf), "%d b", m_timeForBoot);
		SetWindowText(GetDlgItem(IDC_COUNT), buf);
	}
}

void CUISelectDlg::OnStop()
{
	m_timeForBoot++;
	KillTimer(m_hDlgWnd, 1234);
	SetWindowText(GetDlgItem(IDC_COUNT), "NOFF");
}

void CUISelectDlg::OnListDblClick()
{
	::SendMessage(m_hDlgWnd, WM_COMMAND, IDOK, 0);
}

//*******************************************************************
// C
//*******************************************************************

void CUISelectDlg::LoadIniFile(LPCSTR mydir)
{
	std::string iniPath(mydir);

	// ini file name
	iniPath += "\\" MY_NAME;
	iniPath += _T(".ini");
	m_ini.SetIniFileName(iniPath.c_str());

	// auto boot setting
	m_timeForBoot = m_ini.ReadInt("Setting", "TimeForBoot", 5);
	m_bAutoBoot = (m_ini.ReadInt("Setting", "AutoBoot", 0) != 0);
}

// _CAO̕\
CUIPlugin* CUISelectDlg::SelectOnBoot(HINSTANCE hInst, ModuleList &list, LPCSTR mydir)
{
	SetModules(list);
	LoadIniFile(mydir);

	if( m_bAutoBoot ){
		if( ::GetAsyncKeyState(VK_SHIFT) & 0x8000 ){
			m_bAutoBoot = false;
		}else if( m_timeForBoot < 1 ){
			CUIPlugin* pui = GetAutoBoot();
			if( pui != NULL ) return pui;
		}
	}

	DoModal(hInst, NULL);

	return GetSelected();
}

// _CAO̕\
CUIPlugin* CUISelectDlg::Select(HINSTANCE hInst, ModuleList &list, LPCSTR mydir)
{
	SetModules(list);
	LoadIniFile(mydir);

	m_bAutoBoot = false;
	DoModal(hInst, NULL);

	return GetSelected();
}

//*******************************************************************
// EChEvV[W
//*******************************************************************

// JX^c[`bv\
LRESULT CALLBACK CUISelectDlg::NewListProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg){
	case WM_NOTIFY:
		switch( ((LPNMHDR)lParam)->code ){
		case TTN_GETDISPINFO:
			OnGetDispInfo((LPNMTTDISPINFO)lParam);
			return 0;
		}
	}
	return ::CallWindowProc(m_originalListProc, hWnd, uMsg, wParam, lParam);
}
