#pragma once
#include "../nsmsgs/dlg.h"
#include "SettingDlg.h"
#include "UISelector.h"
#include "../nsmsgs/IniFile.h"
#include <string>

class CUISelectDlg: public CDlg
{
private:
	CToolTip m_tip;
	ModuleList* m_pList;
	int m_nSelected;
	CIniFile m_ini;
	int m_timeForBoot;
	bool m_bAutoBoot;
	std::string m_infoString;
	static std::string m_tipStr;
	static WNDPROC m_originalListProc;

public:
	CUISelectDlg(void);
	~CUISelectDlg(void);

	void LoadIniFile(LPCSTR mydir);
	CUIPlugin* SelectOnBoot(HINSTANCE hInst, ModuleList &list, LPCSTR mydir);
	CUIPlugin* Select(HINSTANCE hInst, ModuleList &list, LPCSTR mydir);

	void SetModules(ModuleList &list)
	{
		m_pList = &list;
	}
	CUIPlugin* GetSelected()
	{
		if( 0 <= m_nSelected && m_nSelected < (int)m_pList->size() )
			return (*m_pList)[m_nSelected];
		return NULL;
	}
	void SetInfoString(LPCSTR info)
	{ m_infoString = info; }

private:
	void OnClickSetting();
	static void OnGetDispInfo(LPNMTTDISPINFO lpttd);
	void OnTimer();
	void OnStop();
	void OnListDblClick();
	static LRESULT CALLBACK NewListProc(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam);

	CUIPlugin* GetAutoBoot()
	{
		std::string selUI;

		m_ini.ReadString(selUI, "Setting", "AutoBootUI", "");
		for( int i = 0; i < (int)m_pList->size(); i++ ){
			if( selUI == (*m_pList)[i]->GetPluginInfoTmp(NMPI_TITLE) ){
				return (*m_pList)[i];
			}
		}
		return NULL;
	}

// I[o[Ch
public:
	BOOL DlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam);

private:
	BOOL InitDlgCtrl();
	BOOL GetDlgCtrlValue();
};
