// UISelector.cpp : DLL AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "UISelector.h"
#include "UISelectDlg.h"
#include "CommandLineOption.h"
#include "../nsmsgs/mleak.h"

static CRITICAL_SECTION g_lock;
static HINSTANCE g_hInstance;
static CUIPlugin *g_pUI;
static TNsmPluginInitInfo g_initInfo;

//**********************************************************************
// DLLGg
//**********************************************************************

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID /*lpReserved*/
					 )
{
	if( ul_reason_for_call == DLL_PROCESS_ATTACH ){
		_CrtSetDbgFlag ( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );
		g_hInstance = (HINSTANCE)hModule;
		InitializeCriticalSection(&g_lock);
	}else if( ul_reason_for_call == DLL_PROCESS_DETACH ){
		DeleteCriticalSection(&g_lock);
		delete g_pUI;
	}

	return TRUE;
}

//**********************************************************************
// RegneW[K{֐
//**********************************************************************

int __stdcall GetPluginInfo( int nInfoNo, LPTSTR lpBuffer, int nSize )
{
	int ret;

	WaitForUISelect();

	if( g_pUI != NULL ){
		ret = g_pUI->GetPluginInfo(nInfoNo, lpBuffer, nSize);
	}else{
		switch( nInfoNo ){
		case NMPI_APIVER:		strncpy_s(lpBuffer, nSize, NSM_API_VERSION, nSize); break;
		case NMPI_MODULENAME:	strncpy_s(lpBuffer, nSize, "UI", nSize); break;
		default:				strncpy_s(lpBuffer, nSize, MY_NAME, nSize); break;
		}
		ret = strlen(lpBuffer) + 1;
	}

	return ret;
}

int __stdcall Initialize( PNsmPluginInitInfo lpNsmInitInfo )
{
	int ret = NMP_ALLRIGHT;

	WaitForUISelect();

	if( g_pUI != NULL ){
		ret = g_pUI->Initialize(lpNsmInitInfo);
//		lpNsmInitInfo->HookEvent(NME_SYSTEM_MODULESLOADED, AddMenuItem);
//		g_initInfo = *lpNsmInitInfo;
	}else{
		lpNsmInitInfo->HookEvent(NME_SYSTEM_MODULESLOADED, ExitSystem);
		g_initInfo = *lpNsmInitInfo;
	}

	return ret;
}

int __stdcall Terminate()
{
	int ret = NMP_ALLRIGHT;

	WaitForUISelect();

	if( g_pUI != NULL ){
		ret = g_pUI->Terminate();
	}

	return ret;
}

int __stdcall ExitSystem(WPARAM /*w*/, LPARAM /*l*/)
{
	g_initInfo.CallService(g_initInfo.GetService("System/Exit"), 0, 0);
	return 0;
}

//**********************************************************************
// 
//**********************************************************************

void LoadUIModules(LPCSTR path, ModuleList &list)
{
	HANDLE hFind;
	WIN32_FIND_DATA fileinfo;
	int ret;
	CUIPlugin *pui;
	char findpath[MAX_PATH];

	_snprintf_s(findpath, sizeof(findpath), "%s\\*.dll", path);

	hFind = FindFirstFile(findpath, &fileinfo);
	if( hFind == INVALID_HANDLE_VALUE ) return;

	do
	{
		if( (fileinfo.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0 )
		{
			_snprintf_s(findpath, sizeof(findpath), "%s\\%s", path, fileinfo.cFileName);

			pui = new CUIPlugin(findpath, fileinfo.cFileName);
			if( pui->IsLoadSuccess() ){
				list.push_back(pui);
			}else{
				delete pui;
			}
		}

		ret = FindNextFile(hFind, &fileinfo);
	}
	while( ret != 0 );

	FindClose(hFind);
}

void UnloadModules(ModuleList &list, CUIPlugin *pExcept)
{
	ModuleList::iterator i;

	for( i = list.begin(); i != list.end(); ++i ){
		if( *i != pExcept ) delete *i;
	}
}

void GetMyDir(HMODULE hModule, LPSTR path)
{
	int ret;
	ret = ::GetModuleFileName(hModule, path, MAX_PATH);

	_ASSERT( ret > 0 );
	if( ret > 0 )
	{
		LPSTR pos = strrchr(path, '\\');
		if( pos != NULL )
		{
			const size_t remain = MAX_PATH - (pos - path);
			if( remain >= strlen(MY_NAME) + 2 )
			{
				strcpy_s(pos + 1, remain - 1, MY_NAME);
			}
		}
	}
}

//**********************************************************************
// UIW[ǂݍ
//**********************************************************************

void WaitForUISelect()
{
	static bool sbSelected;

	if( ! sbSelected ){
		EnterCriticalSection(&g_lock);
		if( ! sbSelected ){
			UISelect(g_hInstance);
			sbSelected = true;
		}
		LeaveCriticalSection(&g_lock);
	}
}

void UISelect(HINSTANCE hInst)
{
	char path[MAX_PATH];
	ModuleList list;
	CUISelectDlg dlg;
	CCommandLineOption cmdInfo;

	// UIW[ǂݍ
	GetMyDir((HMODULE)hInst, path);
	LoadUIModules(path, list);

	// UII
	g_pUI = NULL;

	// R}hCUIw肳ꂽ
	if( cmdInfo.IsUISpecified() ){
		ModuleList::const_iterator i;

		for( i = list.begin(); i != list.end(); ++i ){
			if( strcmp((*i)->GetDllName(), cmdInfo.GetSpecifiedDllName()) == 0 ){
				g_pUI = *i;
				break;
			}
		}

		// w肳ꂽUI݂Ȃ
		if( g_pUI == NULL ){
			dlg.SetInfoString("ײ݂Ŏw肳ꂽUI݂͑܂");
		}
	}else{
		// R}hCŎNꂽ
		if( cmdInfo.IsDisableAutoSelect() ){
			dlg.SetInfoString("ײ݂ɂ莩N͖ł");
		}

	}
	if( g_pUI == NULL ){
		// UIIiI_CAO\j
		g_pUI = dlg.SelectOnBoot(hInst, list, path);
	}

	// UIW[A[h
	UnloadModules(list, g_pUI);
}

void RebootWithUISelect(HINSTANCE hInst)
{
	char path[MAX_PATH];
	ModuleList list;
	CUISelectDlg dlg;

	// UIW[ǂݍ
	GetMyDir((HMODULE)hInst, path);
	LoadUIModules(path, list);

	// UIIiI_CAO\j
	g_pUI = dlg.Select(hInst, list, path);

	// UIW[A[h
	UnloadModules(list, NULL);
}
